"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.app = void 0;
const express_1 = __importDefault(require("express"));
const database_1 = require("./database");
const FirestoreClient_1 = require("./FirestoreClient");
class HttpHandler {
    constructor() {
        this.app = express_1.default();
        this.app.put('*', async (req, res) => {
            const firestoreClient = new FirestoreClient_1.FirestoreClient(database_1.database.getDb());
            let result;
            let collection;
            if (req.body.updateIdInTransaction) {
                result = await firestoreClient.runTransaction(async (transaction) => {
                    collection = firestoreClient.getCollection(req.body.collectionName);
                    const document = await collection.getDocument(req.body.updateIdInTransaction, transaction);
                    collection.setDocumentInTransaction(document.id, document, transaction);
                });
                return res.status(200).send(result);
            }
            collection = firestoreClient.getCollection(req.body.collectionName, req.body.optionalFields);
            result = await collection[req.body.methodName].apply(collection, req.body.args);
            return res.status(200).send(result);
        });
    }
}
exports.app = new HttpHandler().app;
//# sourceMappingURL=HttpHandler.js.map